#include <iostream>
#include <string.h>
#include <stdlib.h>
using namespace std;

const int MAXN = 100;
const int MAXC = 50;

enum Lista {VIVA_ITALIA, POPOLO_DEMOCRATICO, ITALIA_DEI_COLORI, 
            FRATELLANZA_NAZIONALE, RIFONDAZIONE_SINISTRA};

struct Candidato {
  char nome[MAXN];
  char cognome[MAXN];
  Lista lista;
  int voti;
};

struct Elez {
  Candidato cand[MAXC];
  int numCand;
  int votiNulli;
};

bool insertCandidato(Elez* pe, const char n[], const char c[], Lista l);
bool voto(Elez* pe, const char n[], const char c[], Lista l);
bool salvaOrd(const Elez* pe, const char nomef[]);
float percentuale(const Elez* pe, Lista l);
int migliori(const Elez* pe, Lista ll[]);

const char* nomiListe[] = {"Viva Italia", "Popolo Democratico", 
                           "Italia dei Colori", "Fratellanza Nazionale", 
                           "Rifondazione Sinistra"};

void stampaLista(Lista l) {
  cout << nomiListe[l] << endl;
}

void stampaTutto(const Elez* pe) {
  cout << "------------------------" << endl;
  cout << "Contenuto della struttura: " << endl;
  for(int i=0; i<pe->numCand; i++) {
    cout << pe->cand[i].nome << " " << pe->cand[i].cognome << " " 
         << nomiListe[pe->cand[i].lista] << " " << pe->cand[i].voti << endl;
  }
  cout << "Voti nulli: " << pe->votiNulli << endl;
  cout << "------------------------" << endl;
}

int main(){
  Elez ele;
  ele.numCand = 0;
  ele.votiNulli = 0;

  cout << "\n\nProvo insertCandidato()" << endl;
  if(insertCandidato(&ele, "Mario", "Rossi", ITALIA_DEI_COLORI)) 
    cout << "Inserimento candidato ok" << endl;
  else cout << "Errore inserimento candidato" << endl;
  if(insertCandidato(&ele, "Silvio", "Bernasconi", VIVA_ITALIA)) 
    cout << "Inserimento candidato ok" << endl;
  else cout << "Errore inserimento candidato" << endl;
  if(insertCandidato(&ele, "Dario", "Franceschetti", POPOLO_DEMOCRATICO)) 
    cout << "Inserimento candidato ok" << endl;
  else cout << "Errore inserimento candidato" << endl;
  if(insertCandidato(&ele, "Nichi", "Comprala", RIFONDAZIONE_SINISTRA)) 
    cout << "Inserimento candidato ok" << endl;
  else cout << "Errore inserimento candidato" << endl;
  if(insertCandidato(&ele, "Antonio", "Diroccia", ITALIA_DEI_COLORI)) 
    cout << "Inserimento candidato ok" << endl;
  else cout << "Errore inserimento candidato" << endl;
  if(insertCandidato(&ele, "Ignazio", "Ladorma", VIVA_ITALIA)) 
    cout << "Inserimento candidato ok" << endl;
  else cout << "Errore inserimento candidato" << endl;
  stampaTutto(&ele);
  system("pause");
 
  cout << "\n\nProvo voto()" << endl;
  if(voto(&ele, "Mario", "Rossi", ITALIA_DEI_COLORI))  
    cout << "Voto ok" << endl;
  else cout << "Voto nullo" << endl;
  if(voto(&ele, "Mario", "Rossi", ITALIA_DEI_COLORI)) 
    cout << "Voto ok" << endl;
  else cout << "Voto nullo" << endl;
  if(voto(&ele, "Silvio", "Bernasconi", POPOLO_DEMOCRATICO)) 
    cout << "Voto ok" << endl;
  else cout << "Voto nullo" << endl;
  if(voto(&ele, "Nichi", "Comprala", RIFONDAZIONE_SINISTRA)) 
    cout << "Voto ok" << endl;
  else cout << "Voto nullo" << endl;
  if(voto(&ele, "Ignazio", "Ladorma", VIVA_ITALIA)) 
    cout << "Voto ok" << endl;
  else cout << "Voto nullo" << endl;
  if(voto(&ele, "Ignazio", "Ladorma", VIVA_ITALIA)) 
    cout << "Voto ok" << endl;
  else cout << "Voto nullo" << endl;
  if(voto(&ele, "Antonio", "Diroccia", ITALIA_DEI_COLORI)) 
    cout << "Voto ok" << endl;
  else cout << "Voto nullo" << endl;
  if(voto(&ele, "Dario", "Franceschetti", POPOLO_DEMOCRATICO)) 
    cout << "Voto ok" << endl;
  else cout << "Voto nullo" << endl;
  stampaTutto(&ele);
  system("pause");

  cout << "\n\nProvo salvaOrd()" << endl;   
  salvaOrd(&ele, "risultati.txt");
  cout << "Contenuto del file risultati.txt:" << endl;
  system("type risultati.txt");
  system("pause");
  
  cout << "\n\nProvo percentuale()" << endl;
  float p = percentuale(&ele, ITALIA_DEI_COLORI);
  cout << "Italia dei colori: " << p << "%" << endl;
  p = percentuale(&ele, VIVA_ITALIA);
  cout << "Viva italia: " << p << "%" << endl;
  p = percentuale(&ele, POPOLO_DEMOCRATICO);
  cout << "Popolo democratico: " << p << "%" << endl;
  p = percentuale(&ele, FRATELLANZA_NAZIONALE);
  cout << "Fratellanza nazionale: " << p << "%" << endl;
  system("pause");

  cout << "\n\nProvo migliori()" << endl;
  Lista ll[3];
  int q = migliori(&ele, ll);
  for(int i=0; i<q; i++)
    stampaLista(ll[i]);
  system("pause");
}
