#include <fstream>
#include <string.h>
using namespace std;

const int MAXN = 100;
const int MAXC = 50;

enum Lista {VIVA_ITALIA, POPOLO_DEMOCRATICO, ITALIA_DEI_COLORI, FRATELLANZA_NAZIONALE, RIFONDAZIONE_SINISTRA};

struct Candidato {
  char nome[MAXN];
  char cognome[MAXN];
  Lista lista;
  int voti;
};

struct Elez {
  Candidato cand[MAXC];
  int numCand;
  int votiNulli;
};

bool insertCandidato(Elez* pe, const char n[], const char c[], Lista l) {
  if(pe->numCand == MAXC)
    return false;
  for(int i=0; i<pe->numCand; i++)
    if(strcmp(n, pe->cand[i].nome) == 0 && strcmp(c, pe->cand[i].cognome) == 0 && l == pe->cand[i].lista)
      return false;
  strcpy(pe->cand[pe->numCand].nome, n);
  strcpy(pe->cand[pe->numCand].cognome, c);
  pe->cand[pe->numCand].lista = l;
  pe->cand[pe->numCand].voti = 0;
  pe->numCand++;
  return true;
}

bool voto(Elez* pe, const char n[], const char c[], Lista l) {
  for(int i=0; i<pe->numCand; i++)
    if(strcmp(n, pe->cand[i].nome) == 0 && strcmp(c, pe->cand[i].cognome) == 0 && l == pe->cand[i].lista) {
      pe->cand[i].voti++;
      return true;
    }
  pe->votiNulli++;
  return false;
}

void ordina(Candidato v[], int n) {
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++)
      if(v[j].voti > v[index].voti)
        index = j;
    Candidato a = v[i];
    v[i] = v[index];
    v[index] = a;
  }
}

bool salvaOrd(const Elez* pe, const char nomef[]) {
  Candidato tmp[MAXC];
  int n = pe->numCand;
  for(int i=0; i<n; i++)
    tmp[i] = pe->cand[i];
  ordina(tmp, n);
  fstream ff;
  ff.open(nomef, ios::out);
  if(!ff)
    return false;
  for(int i=0; i<n; i++)
    ff << tmp[i].voti << " " << tmp[i].nome << " " << tmp[i].cognome << endl;
  ff.close();
  return true;
}

float percentuale(const Elez* pe, Lista l) {
  int tot = 0;
  float votil = 0.0f;
  for(int i=0; i<pe->numCand; i++){
    tot += pe->cand[i].voti;
    if(pe->cand[i].lista == l)
      votil += pe->cand[i].voti;
  }
  return votil/tot*100.0f;
}

struct VotiLista {
  int voti;
  Lista l;
};

int migliori(const Elez* pe, Lista ll[]) {
  const int n = RIFONDAZIONE_SINISTRA+1;
  VotiLista tmp[n];
  for(int i=0; i<n; i++) {
    tmp[i].voti=0;
    tmp[i].l = (Lista)i;
  }
  for(int i=0; i<pe->numCand; i++)
    tmp[pe->cand[i].lista].voti += pe->cand[i].voti;
  for(int i=0; i<n-1; i++) {
    int index = i;
    for(int j=i+1; j<n; j++)
      if(tmp[j].voti > tmp[index].voti)
        index = j;
    VotiLista a = tmp[i];
    tmp[i] = tmp[index];
    tmp[index] = a;
  }
  int q = n<3 ? n : 3;
  for(int i=0; i<q; i++)
    ll[i] = tmp[i].l;
  return q;
}

